#include "srf.h"

#define _SRF_MERENI  70

bool     _SRF_aktivni = 0;
uint8_t  _SRF_adresa;
uint32_t _SRF_cas;
uint16_t _SRF_perioda, _SRF_dT;
uint16_t _SRF_hodnota = 0;

void SRF_nastav(uint16_t perioda, byte adresa) {
  _SRF_adresa = adresa >> 1;
  _SRF_cas = millis();
  _SRF_perioda = perioda;
  _SRF_dT = _SRF_perioda;
  Wire.begin();
}

bool SRF_delej() {
  if (millis() - _SRF_cas >= _SRF_dT) {
    if (_SRF_aktivni == 0) {
      _SRF_aktivni = 1;
      _SRF_cas += _SRF_perioda;
      _SRF_dT = _SRF_MERENI;
      // spusteni mereni
      Wire.beginTransmission(_SRF_adresa);  
      Wire.write((uint8_t)0x00);
      Wire.write((uint8_t)0x51);
      Wire.endTransmission();
    } else {
      _SRF_aktivni = 0;
      _SRF_dT = _SRF_perioda;
      // cteni zmerene hodnoty
      Wire.beginTransmission(_SRF_adresa);  
      Wire.write((uint8_t)0x02);
      Wire.endTransmission();
      Wire.requestFrom(_SRF_adresa, (uint8_t)2);
      if (Wire.available() >= 2) {
        _SRF_hodnota = (uint16_t)Wire.read() << 8;
        _SRF_hodnota |= Wire.read();
        return 1;
      }
    }
  }
  return 0;
}

uint16_t SRF_cti() {
  return _SRF_hodnota;
}


